//+------------------------------------------------------------------+
//|                                                   i-Sessions.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|  16.11.2005                               |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window

//-------    -------------------------------
extern int    NumberOfDays = 100;        //  
extern string AsiaBegin    = "00:00";   //   
extern string AsiaEnd      = "08:00";   //   
extern color  AsiaColor    = C'50,50,50'; //   
extern string EABegin      = "08:00";   //   
extern string EAEnd        = "11:00";   //   
extern color  EAColor      = Red; //   
extern string EurBegin     = "11:00";   //   
extern string EurEnd       = "14:00";   //   
extern color  EurColor     = C'50,50,50';       //   
extern string EUBegin      = "14:00";   //   
extern string EUEnd        = "17:00";   //   
extern color  EUColor      = C'100,100,100';       //   
extern string USABegin     = "17:00";   //   
extern string USAEnd       = "23:00";   //   
extern color  USAColor     = C'50,50,50'; //   


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  DeleteObjects();
  for (int i=0; i<NumberOfDays; i++) {
    CreateObjects("AS2"+i, AsiaColor);
    CreateObjects("EA2"+i, EAColor);
    CreateObjects("ER2"+i, EurColor);
    CreateObjects("EU2"+i, EUColor);
    CreateObjects("US2"+i, USAColor);
  }
  Comment("");
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  DeleteObjects();
  Comment("");
}

//+------------------------------------------------------------------+
//|                                        |
//| :                                                       |
//|   no -                                        |
//|   cl -                                                |
//+------------------------------------------------------------------+
void CreateObjects(string no, color cl) {
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, false);
}

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void DeleteObjects() {
  for (int i=0; i<NumberOfDays; i++) {
    ObjectDelete("AS2"+i);
    ObjectDelete("EA2"+i);
    ObjectDelete("ER2"+i);
    ObjectDelete("EU2"+i);
    ObjectDelete("US2"+i);
  }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  datetime dt=CurTime();

  for (int i=0; i<NumberOfDays; i++) {
    DrawObjects(dt, "AS2"+i, AsiaBegin, AsiaEnd);
    DrawObjects(dt, "EA2"+i, EABegin, EAEnd);
    DrawObjects(dt, "ER2"+i, EurBegin, EurEnd);
    DrawObjects(dt, "EU2"+i, EUBegin, EUEnd);
    DrawObjects(dt, "US2"+i, USABegin, USAEnd);
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
  }
}

//+------------------------------------------------------------------+
//|                                       |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   tb -                                          |
//|   te -                                       |
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te) {
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  p1=High[Highest(NULL,0,MODE_HIGH,b1-b2,b2)];
  p2=Low[Lowest(NULL,0,MODE_LOW,b1-b2,b2)];
  ObjectSet(no, OBJPROP_TIME1 , t1);
  ObjectSet(no, OBJPROP_PRICE1, p1);
  ObjectSet(no, OBJPROP_TIME2 , t2);
  ObjectSet(no, OBJPROP_PRICE2, p2);
}

//+------------------------------------------------------------------+
//|                                  |
//| :                                                       |
//|   dt -                                           |
//+------------------------------------------------------------------+
datetime decDateTradeDay (datetime dt) {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+

